//
//  FlatteningEngine.h
//  ParchmentFlattener
//
//  Copyright (c) 2014 Kazim Pal.
//  Released under the MIT License.
//
#pragma once
#include <Eigen/Dense>
class IGLMesh;
class LIMData;

class FlatteningEngine
{
public:
    FlatteningEngine(void);
    ~FlatteningEngine(void);

    void rebuildLimData(IGLMesh *wMesh);
    int singleStep(IGLMesh *wMesh);
    int initialFlattenTuttePlusLIM(IGLMesh *wMesh);
    void deleteLimData();

private:
    LIMData *limData;
    Eigen::MatrixXd flattenTutte(IGLMesh *wMesh);
};

