#include "MyGLWidget.h"
#ifdef TARGET_OS_MAC
#include <glu.h>
#else
#include <GL/glu.h>
#endif
#include "QIGLMesh.h"
#include "qparchmentflattener.h"



MyGLWidget::MyGLWidget(void)
{
}

MyGLWidget::MyGLWidget(QWidget *parent, QGLWidget *share) : QGLWidget(parent,share)
{
}

MyGLWidget::~MyGLWidget(void)
{
}

QSize MyGLWidget::minimumSizeHint() const
{
    return QSize(50, 50);
}

QSize MyGLWidget::sizeHint() const
{
    return QSize(1200, 800);
}

QSize MyGLWidget::getGLSize()
{
    return QSize(window_width,window_height);
}





void MyGLWidget::renderMesh()
{
    mesh->render();
}



void MyGLWidget::setModelViewMatrixGL()
{
    Vector3d eye = target_new - camz * currentGravity;
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt(eye(0),eye(1),eye(2),target_new(0),target_new(1),target_new(2),currentUpVec(0),currentUpVec(1),currentUpVec(2));
    //glMultMatrixd(rotation_matrix);
}

void MyGLWidget::setModelViewMatrixGL(Vector3d mvTarget)
{
    Vector3d eye = mvTarget - camz * currentGravity;
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt(eye(0),eye(1),eye(2),mvTarget(0),mvTarget(1),mvTarget(2),currentUpVec(0),currentUpVec(1),currentUpVec(2));
    //glMultMatrixd(rotation_matrix);
}





void MyGLWidget::setFakeHoverPoint(int winX, int winY)
{
    GLfloat winZ_gl = 0;
    glReadPixels( int(winX), int(winY), 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &winZ_gl );
    double winZ = (double)winZ_gl;
    znear = Z_NEAR_PROJ;
    setProjectionMatrixGL();
    znear = Z_NEAR_MAIN;
    setModelViewMatrixGL();
    Vector3d Q = fullUnProjectionGL(winX,winY,winZ);
    mesh->fake_hover = Q;
}

void MyGLWidget::renderScaleConstraints()
{

}

void MyGLWidget::renderLineConstraints()
{

}

void MyGLWidget::hoverChangedSlot()
{
    updateGL();
}


