#pragma once
#include <QGLWidget>
#include <qvector3d.h>
#include <igl/trackball.h>
#include <Eigen/Dense>

class MyGLWidget : public QGLWidget
{
Q_OBJECT
public:


	MyGLWidget(void);
    MyGLWidget(QWidget *parent, QGLWidget *share);
	~MyGLWidget(void);

    QSize minimumSizeHint() const;
    QSize sizeHint() const;
    QSize getGLSize();



public slots:
    void hoverChangedSlot();

protected:
    virtual void initializeGL() = 0;
    virtual void paintGL() = 0;
    virtual void resizeGL(int width, int height) = 0;
    virtual void mousePressEvent(QMouseEvent * e) = 0;
    virtual void mouseMoveEvent(QMouseEvent * e) = 0;
    virtual void mouseReleaseEvent(QMouseEvent * e) = 0;
    virtual void mouseClickEvent(QMouseEvent *e) = 0;
    virtual void wheelEvent(QWheelEvent * e) = 0;
    virtual void renderMesh();
    virtual void renderLineConstraints();
    virtual void renderScaleConstraints();
    virtual bool clickOnMesh(double winX, double winY, int *k, double *s, double *t, Vector3d *p) = 0;
    //virtual void handleClick(int winX, int winY) = 0;

    virtual void setFakeHoverPoint(int winX, int winY);
    virtual Vector3d getSurfacePoint(int k, double s, double t) = 0;




    //QPointF fullProjection(QMatrix4x4 pMatrix, QMatrix4x4 mvMatrix, int v_width, int v_height, QVector3D v);
    //void fullProjection(QMatrix4x4 pMatrix, QMatrix4x4 mvMatrix, int v_width, int v_height, QVector3D v, double *winX, double *winY);
    //QVector3D fullUnProjection(QMatrix4x4 pMatrix, QMatrix4x4 mvMatrix, int v_width, int v_height, QPointF p, double depth);
    //void fullUnProjection(QMatrix4x4 pMatrix, QMatrix4x4 mvMatrix, int v_width, int v_height, QPointF p, double depth, double *posX, double *posY, double *posZ);


private:

};
